
// TestAppDlg.cpp : t@C
//

#include "stdafx.h"
#include "TestApp.h"
#include "TestAppDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CTestAppDlg _CAO

CTestAppDlg::CTestAppDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CTestAppDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CTestAppDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CTestAppDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &CTestAppDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CTestAppDlg::OnBnClickedCancel)
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_BTN_RUN, &CTestAppDlg::OnBnClickedBtnRun)
END_MESSAGE_MAP()

// CTestAppDlg bZ[W nh

BOOL CTestAppDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// ̃_CAÕACRݒ肵܂BAvP[ṼC EBhE_CAOłȂꍇA
	//  Framework ́A̐ݒIɍs܂B
	SetIcon(m_hIcon, TRUE);			// 傫ACR̐ݒ
	SetIcon(m_hIcon, FALSE);		// ACR̐ݒ

	// TODO: ɒǉ܂B

	return TRUE;  // tH[JXRg[ɐݒ肵ꍇATRUE Ԃ܂B
}

// _CAOɍŏ{^ǉꍇAACR`悷邽߂
//  ̃R[hKvłBhLg/r[ fg MFC AvP[V̏ꍇA
//  ́AFramework ɂĎIɐݒ肳܂B

void CTestAppDlg::OnPaint()
{
	if(IsIconic())
	{
		CPaintDC dc(this); // `̃foCX ReLXg

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// NCAg̎lp`̈̒
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// ACR̕`
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// [U[ŏEBhEhbOĂƂɕ\J[\擾邽߂ɁA
//  VXe̊֐Ăяo܂B
HCURSOR CTestAppDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CTestAppDlg::OnBnClickedOk()
{
}

void CTestAppDlg::OnBnClickedCancel()
{
}

void CTestAppDlg::OnClose()
{
	CDialog::EndDialog(IDCLOSE);
}

void CTestAppDlg::InitHeader()
{
	CListCtrl* list = (CListCtrl*)GetDlgItem(IDC_LIST1);

	wchar_t caption[][32] = {L"parentId"
								, L"parentName"
								, L"id"
								, L"name"
								, L"actualSize"
								, L"modification"
								, L"flag"
								};

	int widht = 110;

	int count = sizeof(caption) / sizeof(caption[0]);

	list->SetExtendedStyle(LVS_EX_FULLROWSELECT);

	for(int i = 0; i < count; i++){
		if(list->InsertColumn(i, caption[i], LVCF_TEXT | LVCF_SUBITEM | LVCFMT_LEFT, widht) == -1){
			return;
		}
	}
}

void CTestAppDlg::RowsAdd(int parentId
							, wchar_t *parentName
							, int id
							, wchar_t *name
							, __int64 actualSize
							, __int64 modification
							, int flag
							)
{
	CListCtrl* list = (CListCtrl*)GetDlgItem(IDC_LIST1);

	int index = (list->GetItemCount() - 1) + 1;

	CString text;

	text.Format(L"%d", parentId);
	if(list->InsertItem(LVIF_TEXT, index, text, 0, 0, 0, 0) == -1){
		return;
	}

	text = parentName;
	if(list->SetItem(index, 1, LVIF_TEXT, text, 0, 0, 0, 0) == -1){
		return;
	}

	text.Format(L"%d", id);
	if(list->SetItem(index, 2, LVIF_TEXT, text, 0, 0, 0, 0) == -1){
		return;
	}

	text = name;
	if(list->SetItem(index, 3, LVIF_TEXT, text, 0, 0, 0, 0) == -1){
		return;
	}

	text.Format(L"%I64d", actualSize);
	if(list->SetItem(index, 4, LVIF_TEXT, text, 0, 0, 0, 0) == -1){
		return;
	}
	
	text.Format(L"%I64d", modification);
	if(list->SetItem(index, 5, LVIF_TEXT, text, 0, 0, 0, 0) == -1){
		return;
	}

	text.Format(L"%d", flag);
	if(list->SetItem(index, 6, LVIF_TEXT, text, 0, 0, 0, 0) == -1){
		return;
	}
}

void CTestAppDlg::OnBnClickedBtnRun()
{
	int result;

	unsigned int drive = 2; // C Drive

	size_t count;

	DWORD time = GetTickCount();

	// ǂݍ
	if((result = LoadMft(drive, count)) != 0){
		AfxMessageBox(GetMftMessage(result));
		return;
	}

	m_resultRecord.resize(count);

	// 擾
	if((result = GetData(&m_resultRecord[0]) != 0)){
		AfxMessageBox(GetMftMessage(result));
		return;
	}

	CString text;
	text.Format(L"%.3f sec", (GetTickCount() - time) / 1000.0);
	SetWindowText(text);

	InitHeader();

	CListCtrl* list = (CListCtrl*)GetDlgItem(IDC_LIST1);

	list->DeleteAllItems();

	list->SetRedraw(FALSE);

	for(unsigned int i = 0; i < m_resultRecord.size(); i++){
		RowsAdd(m_resultRecord[i].parentId
					, m_resultRecord[i].parentName
					, m_resultRecord[i].id
					, m_resultRecord[i].name
					, m_resultRecord[i].actualSize
					, m_resultRecord[i].modificationTime
					, m_resultRecord[i].flag);
	}

	list->SetRedraw(TRUE);

	list->SetItemState(0, LVIS_SELECTED | LVIS_FOCUSED, LVIS_SELECTED | LVIS_FOCUSED);
	list->SetSelectionMark(0);
}
